﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NUnit.Framework;
using System.Reflection;
using Spring.Context;
using Spring.Context.Support;
using Spring.Objects.Factory.Config;


namespace ClassLibrary1
{
    [TestFixture]
    public class DoSomeWorkTests
    {
        [Test]
        public void CanDoWork()
        {
            ConnectionManager connectionManager = new ConnectionManager();
            DataAccess dataAccess = new DataAccess(connectionManager);
            DataPrinter dataPrinter = new DataPrinter();
            DataSorter dataSorter = new DataSorter();

            var worker = new Worker(dataAccess, dataSorter, dataPrinter);

            worker.DoWork();
        }

        [Test]
        public void CanDoWorkEasily()
        {
            var context = new GenericApplicationContext();

            context.Configure(new StandardObjectConfiguration(AutoWiringMode.Constructor)
                .DefineObject<Logger>()
                .DefineObject<DataAccess>()
                .DefineObject<DataPrinter>()
                .DefineObject<DataSorter>()
                .DefineObject<Worker>()
                .DefineObject<ConnectionManager>()

                );

            var worker = context.GetObject<Worker>();

            worker.DoWork();

        }

    }
}
