﻿using NUnit.Framework;
using Spring.Context;
using Spring.Context.Support;
using Spring.Objects.Factory.Config;

namespace ClassLibrary1
{
    [TestFixture]
    public class DoSomeWorkTests
    {
        [Test]
        public void CanDoWork()
        {
            Logger logger = new Logger();
            ConnectionManager connectionManager = new ConnectionManager(logger);
            DataAccess dataAccess = new DataAccess(connectionManager, logger);
            DataPrinter dataPrinter = new DataPrinter(logger);
            DataSorter dataSorter = new DataSorter(logger);

            var worker = new Worker(dataAccess, dataSorter, dataPrinter, logger);

            worker.DoWork();
        }

        [Test]
        public void CanDoWorkEasily()
        {
            var context = new GenericApplicationContext();

            context.Configure(new StandardObjectConfiguration(AutoWiringMode.Constructor)
                .DefineObject<Logger>()
                .DefineObject<DataAccess>()
                .DefineObject<DataPrinter>()
                .DefineObject<DataSorter>()
                .DefineObject<Worker>()
                .DefineObject<ConnectionManager>()

                );

            var worker = context.GetObject<Worker>();

            worker.DoWork();

        }



    }
}
