﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Diagnostics;

namespace ClassLibrary1
{
    


    


    public class Logger
    {
        public void Log(string message)
        {
            Debug.WriteLine(String.Format("LOGGER: {0}", message));
        }
    }


    public class ConnectionManager
    {
        private Logger _logger;
        /// <summary>
        /// Initializes a new instance of the ConnectionManager class.
        /// </summary>
        public ConnectionManager(Logger logger)
        {
            _logger = logger;

        }


        public string GetConnectionString()
        {
            _logger.Log("Gettin connection string...");
            //get connection string from config file or something...
            return "I am the connection string here!";
        }
    }

    public class OtherDataAccess : IDataAccess
    {

        public IEnumerable<string> GetData()
        {
            throw new NotImplementedException();
        }
    }
    public interface IDataAccess
    {
        IEnumerable<string> GetData();
    }



    public class DataAccess : IDataAccess
    {


        private Logger _logger;
        private ConnectionManager _connectioManger;
        /// <summary>
        /// Initializes a new instance of the DataAccess class.
        /// </summary>
        public DataAccess(ConnectionManager connectioManger, Logger logger)
        {
            _logger = logger;
            _connectioManger = connectioManger;

        }


        public virtual IEnumerable<string> GetData()
        {
            string connectionString = _connectioManger.GetConnectionString();
            _logger.Log("Getting data...");

            //do something with connection string in here...
            return new string[] { "one", "two", "three", "four" };
        }
    }

    public class DataSorter
    {
        private Logger _logger;
        /// <summary>
        /// Initializes a new instance of the DataSorter class.
        /// </summary>
        public DataSorter(Logger logger)
        {
            _logger = logger;

        }


        public IEnumerable<string> SortData(IEnumerable<string> data)
        {
            _logger.Log("Sorting data...");

            var orderedData = from item in data orderby item select item;
            return orderedData;

        }
    }

    public class DataPrinter
    {
        private Logger _logger;
        /// <summary>
        /// Initializes a new instance of the DataPrinter class.
        /// </summary>
        public DataPrinter(Logger logger)
        {
            _logger = logger;

        }

        public void PrintData(IEnumerable<string> data)
        {
            _logger.Log("Printing Data...");

            foreach (string item in data)
            {
                Debug.WriteLine(item);
            }
        }
    }

    public class Worker
    {
        private DataAccess _dataAccess;

        private DataPrinter _dataPrinter;

        private Logger _logger;
        private DataSorter _dataSorter;

        /// <summary>
        /// Initializes a new instance of the Worker class.
        /// </summary>
        public Worker(DataAccess dataAccess, DataSorter dataSorter, DataPrinter dataPrinter, Logger logger)
        {
            _logger = logger;
            _dataPrinter = dataPrinter;
            _dataSorter = dataSorter;
            _dataAccess = dataAccess;


        }

        public void DoWork()
        {
            _logger.Log("Doing the work...");

            IEnumerable<string> data = _dataAccess.GetData();

            data = _dataSorter.SortData(data);

            _dataPrinter.PrintData(data);

        }

    }
}
