// Type: Strongshell.Recoil.Core.Composition.WiringContainer
// Assembly: Strongshell.Recoil.Core, Version=1.1.2.0, Culture=neutral
// Assembly location: C:\_talks\Fairfield Westchester CodeCamp 2010\Taming Dependency Chaos with IoC Containers\code\03-Working_final\Lib\Spring\Strongshell.Recoil.Core.dll

using Spring.Objects.Factory.Support;
using Strongshell.Recoil.Core.Composition.Parsing;
using Strongshell.Recoil.Core.Composition.Workflow;
using System;
using System.Collections.Generic;
using System.Linq.Expressions;

namespace Strongshell.Recoil.Core.Composition
{
    public abstract class WiringContainer : IObjectConfigurationRegistry
    {
        public IExpressionParserFactory ExpressionParserFactory { get; set; }

        #region IObjectConfigurationRegistry Members

        public IObjectNameFactory NameFactory { get; set; }
        public List<ObjectConfiguration> ObjectConfigurations { get; }
        public IObjectDefinitionFactory ObjectDefinitionFactory { get; set; }
        ObjectConfiguration IObjectConfigurationRegistry.Register(Type type);
        ObjectConfiguration IObjectConfigurationRegistry.RegisterUnique(Type type);

        #endregion

        protected IDefinitionFragment<TType> Define<TType>() where TType : class;

        protected IDefinitionFragment<TType> Define<TType>(Expression<Func<TType>> instantiatonExpression)
            where TType : class;

        protected IDefinitionFragment<TType> Define<TType>(string parentName) where TType : class;

        protected IDefinitionFragment<TType> Define<TType>(INamedDefinitionFragment parentDefinition)
            where TType : class;

        protected IDefinitionFragment<TType> Define<TType>(Expression<Func<TType>> instantiatonExpression,
                                                           string parentName) where TType : class;

        protected IDefinitionFragment<TType> Define<TType>(Expression<Func<TType>> instantiatonExpression,
                                                           INamedDefinitionFragment parentDefinition)
            where TType : class;

        public abstract void SetupContainer();

        public static TDependency Wire<TDependency>();
        public static TDependency Wire<TDependency>(string reference);
    }
}
